#!/usr/bin/env python3
import utils
import json


def write_conf():
    with open('/etc/miris/netcapture.json.example', 'r') as f:
        default_conf = json.load(f)
    default_conf['docker_registry_login'] = utils.get_conf('NETCAPTURE_DOCKER_LOGIN', '')
    default_conf['docker_registry_password'] = utils.get_conf('NETCAPTURE_DOCKER_PWD', '')
    default_conf['campusmanager_url'] = 'https://%s' % utils.get_conf('CM_SERVER_NAME', '')
    with open('/etc/miris/netcapture.json', 'w') as f:
        json.dump(default_conf, f, indent=2, sort_keys=True)
    return default_conf


def setup(interactive=True):
    # Run commands
    cmds = [
        'apt-get install --yes apt-transport-https ca-certificates curl software-properties-common',
        'curl -fsSL https://download.docker.com/linux/ubuntu/gpg | apt-key add -',
        'add-apt-repository "deb [arch=amd64] https://download.docker.com/linux/ubuntu $(lsb_release -cs) stable"',
        'apt-get update && apt-get install --yes docker-ce',
        'apt-get install --yes python3-miris-netcapture',
    ]

    try:
        utils.run_commands(cmds)
        conf = write_conf()
        cmds_post = list()
        for f in ['media', 'conf']:
            cmds_post.extend([
                'mkdir -p %s' % conf['netcapture_%s_folder' % f],
                'chgrp -R video %s' % conf['netcapture_%s_folder' % f],
                'chmod -R 774 %s' % conf['netcapture_%s_folder' % f],
            ])
        utils.run_commands(cmds_post)
    except Exception:
        raise
